accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views

from accounts.views import signup


urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.contrib.auth import views as auth_views
from django.views.generic.base import RedirectView


urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("admin/", admin.site.urls),
    path("accounts/", include("accounts.urls")),
    path("receipts/", include("receipts.urls")),
    path("", RedirectView.as_view(url=reverse_lazy("home"))),
]

receipts/urls.py
from receipts.views import (
    ReceiptListView,
    AccountCreateView,
    ExpenseCategoryCreateView,
    ReceiptCreateView,
    ExpenseCategoryListView,
    AccountListView,
)
from django.urls import path

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("accounts/", AccountListView.as_view(), name="account_listview"),
    path(
        "categories",
        ExpenseCategoryListView.as_view(),
        name="category_listview",
    ),
    path(
        "categories/new/",
        ExpenseCategoryCreateView.as_view(),
        name="category_createview",
    ),
    path(
        "account/new/",
        AccountCreateView.as_view(),
        name="account_createview",
    ),
    path(
        "receipts/new",
        ReceiptCreateView.as_view(),
        name="receipts_createview",
    ),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from django.db import models
from django.conf import settings

# Create your models here.

USER_MODEL = settings.AUTH_USER_MODEL


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="categories",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        USER_MODEL, related_name="accounts", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateTimeField(auto_now_add=True)
    purchaser = models.ForeignKey(
        USER_MODEL, related_name="receipts", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        "ExpenseCategory", related_name="receipts", on_delete=models.CASCADE
    )
    account = models.ForeignKey(
        "Account",
        related_name="receipts",
        on_delete=models.CASCADE,
        null=True,
    )

accounts/views.py
from django.contrib.auth import login
from django.shortcuts import redirect, render
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(username, password)
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

receipts/views.py
from django.shortcuts import redirect
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.edit import CreateView
from receipts.models import Receipt, ExpenseCategory, Account
from django.views.generic.list import ListView

# Create your views here.


class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ExpenseCategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "expense/list.html"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user)


class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "account/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user)


class ExpenseCategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    template_name = "expense/new.html"
    fields = ["name"]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("home")


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "account/new.html"
    fields = ["name", "number"]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("home")


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    template_name = "receipts/new.html"
    fields = [
        "vendor",
        "total",
        "tax",
        "purchaser",
        "category",
        "account",
    ]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("home")

accounts/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Django Two Tap</title>
    <link rel="stylesheet" href="{% static 'css/app.css' %}" />
  </head>
  <body>
    <header>
      <nav>
        <ul>
          {% if user.is_authenticated %}
          <li>
            <a href="{% url 'home' %}">Home</a>
          </li>
          <li>
            <a href="{% url 'logout' %}">Logout</a>
          </li>
          <li>
            <a href="{% url 'account_listview' %}">Account</a>
          </li>
          <li>
            <a href="{% url 'category_listview' %}">Expenses</a>
          </li>
          <li>
            <a href="{% url 'category_createview' %}">Expenses Update</a>
          </li>
          <li>
            <a href="{% url 'account_createview' %}">Account Update</a>
          </li>
          <li>
            <a href="{% url 'receipts_createview' %}">Receipts Update</a>
          </li>
          {% else %}
          <li>
            <a href="{% url 'login' %}">Login</a>
          </li>
          <li>
            <a href="{% url 'signup' %}">Sign Up</a>
          </li>
          {% endif %}
        </ul>
      </nav>
    </header>
    <div></div>
    {% block content %} {% endblock content %}
  </body>
</html>

receipts/templates/expense/list.html
{% extends 'base.html' %} {% block content %}

<main>
  <h2>Money Theives</h2>
  <table>
    <thead>
      <tr>
        <th colspan="2">Expenses</th>
      </tr>
      <tr>
        <th>Name</th>
        <th>Number of Receipts</th>
      </tr>
    </thead>
    <tbody>
      {% for expense in expensecategory_list %}
      <tr>
        <td>{{ expense.name }}</td>
        <td>{{ expense.receipts.all|length }}</td>
        {% endfor %}
      </tr>
    </tbody>
  </table>
</main>
{% endblock content %}

receipts/templates/expense/new.html
{% extends 'base.html' %} {% block content %}
<main class="receipts-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Create</button>
    </div>
  </form>
</main>
{% endblock content %}

receipts/templates/receipts/list.html
{% extends 'base.html' %} {% block content %}

<main>
  <table>
    <thead>
      <tr>
        <th colspan="6">Receipts</th>
      </tr>
      <tr>
        <th>Vendor</th>
        <th>total</th>
        <th>Tax</th>
        <th>Date</th>
        <th>Category</th>
        <th>Account</th>
      </tr>
    </thead>
    <tbody>
      {% for info in receipt_list %}
      <tr>
        <td>{{ info.vendor }}</td>
        <td>{{ info.total }}</td>
        <td>{{ info.tax }}</td>
        <td>{{ info.date }}</td>
        <td>{{ info.category }}</td>
        <td>{{ info.account }}</td>
      </tr>
      {% endfor %}
    </tbody>
  </table>
</main>

{% endblock content %}

receipts/templates/receipts/new.html
{% extends 'base.html' %} {% block content %}
<main class="receipts-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Create</button>
    </div>
  </form>
</main>
{% endblock content %}